
/*--------------------------------------------------------------------
| Disclamer: Este código foi feito um pouco à pressa. Não 
|            está perfeito mas ilustra a utilização da mplib
---------------------------------------------------------------------*/

/*--------------------------------------------------------------------
| Includes
---------------------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <pthread.h>

#include "mplib3.h"

/*--------------------------------------------------------------------
| Defines
---------------------------------------------------------------------*/

#define BUFFSZ 256

typedef struct {
  int   id;
  char* token;
} argsSimular_t;


/*--------------------------------------------------------------------
| Function: toupper_token
---------------------------------------------------------------------*/

int toupper_token (char* str, char* token) {
   int      occurrences = 0;
   char*    target = str;
   int      sztoken = strlen(token);
   int      i;
 
   while (target = strstr (target, token)) {
     occurrences++;
     for (i=0; i<sztoken; i++)
       target[i] = toupper(target[i]);
     target++;
   }
   return occurrences;
}

/*--------------------------------------------------------------------
| Function: filter
---------------------------------------------------------------------*/

void *filter(void *a) {
   argsSimular_t *arg   = (argsSimular_t *) a;
   int           myid     = arg->id;
   int           anterior = arg->id-1;
   int           proximo  = arg->id+1;
   char*         token    = arg->token;
   char          buffer[BUFFSZ];
   int           occurrences = 0;


   printf ("thread %d, anterior = %d, proximo = %d, mytoken=%s\n", myid, anterior, proximo, token);
   
   while (1) {
     receberMensagem (anterior, myid, buffer, BUFFSZ);
     occurrences = toupper_token (buffer, token);
     if (occurrences)
       enviarMensagem (myid, proximo, buffer, strlen(buffer)+1);
   }
   return 0;
} 


/*--------------------------------------------------------------------
| Function: printer
---------------------------------------------------------------------*/

void *printer(void *a) {
   argsSimular_t *arg   = (argsSimular_t *) a;
   int           myid = arg->id;
   int           anterior = arg->id-1;
   int           proximo  = arg->id+1;
   char          buffer[BUFFSZ];

   printf ("thread %d, anterior = %d, proximo = %d\n", myid, anterior, proximo);
   
   while (1) {
     receberMensagem (anterior, myid, buffer, BUFFSZ);
     printf ("%s\n",buffer);
   }
   return 0;
} 

/*--------------------------------------------------------------------
| Function: main
| Description: cria n threads
|              para cada um dos filhos recebe uma mensagem e envia 
               uma resposta n vezes
---------------------------------------------------------------------*/


int main (int argc, char** argv) {
  argsSimular_t *slave_args;
  pthread_t     *slaves;
  char          *token1 = argv[1];
  char          *token2 = argv[2];
  char          buffer[BUFFSZ];

  if (argc < 3) {
    printf("pipeline token1 token2\n");
    return 1;
  }

  slave_args = (argsSimular_t*)malloc(3*sizeof(argsSimular_t));
  slaves     = (pthread_t*)malloc(3*sizeof(pthread_t));

  if (inicializarMPlib(10,4) == -1) {
    printf("Erro ao inicializar MPLib.\n"); return 1;
  }

  slave_args[0].id = 1;
  slave_args[0].token = token1;
  pthread_create(&slaves[0], NULL, filter, &slave_args[0]);

  slave_args[1].id = 2;
  slave_args[1].token = token2;
  pthread_create(&slaves[1], NULL, filter, &slave_args[1]);

  slave_args[2].id = 3;
  pthread_create(&slaves[2], NULL, printer, &slave_args[2]);

  while (fgets (buffer, BUFFSZ, stdin)) {
     enviarMensagem (0, 1, buffer, strlen(buffer)+1);
  }
}
